// This may look like C code, but it is really -*- C++ -*-
/*
  arithmetic, etc. functions on built in types
*/

#ifndef _builtin_h
#ifdef __GNUG__
#pragma interface
#endif
#define _builtin_h 1

inline double abs(const double arg)
{
  return (arg < 0.0)? -arg : arg;
}

inline float abs(const float arg)
{
  return (arg < 0.0)? -arg : arg;
}

inline short abs(const short arg)
{
  return (arg < 0)? -arg : arg;
}

inline long abs(const long arg)
{
  return (arg < 0)? -arg : arg;
}

inline double sqr(const double arg)
{
  return arg * arg;
}

inline long sqr(const long arg)
{
  return arg * arg;
}

inline float sqr(const float arg)
{
  return arg * arg;
}

#ifndef M_PI
#  define M_PI          3.14159265358979323846
//#define M_PI	_PI
#endif

inline double hypot(const double a, const double b)
{ return sqrt(a*a+b*b); }

#endif
